'use strict'

let cli = require('heroku-cli-util')
let co = require('co')

function * run (context, heroku) {
  cli.yubikey.enable()
  let code = yield cli.prompt('Two-factor code', {mask: true})
  cli.yubikey.disable()
  yield cli.preauth(context.app, heroku, code)
}

const cmd = {
  description: 'add a pre-authorizations to perform actions on a paranoid app without two-factor authentication',
  needsAuth: true,
  needsApp: true,
  run: cli.command(co.wrap(run))
}

module.exports = [
  Object.assign({topic: '2fa', command: 'preauth'}, cmd),
  Object.assign({topic: 'preauth', hidden: true}, cmd)
]
