'use strict'

let cli = require('heroku-cli-util')
let co = require('co')

function * run (context, heroku) {
  let otp = yield cli.prompt('Press your new yubikey', {mask: true})
  // if (otp.length !== 44) {
    // cli.error('Invalid OTP. Should have 44 characters.');
  // }
  let secondFactor
  if ((yield heroku.request({path: '/users/~'})).two_factor_authentication) {
    secondFactor = yield cli.prompt('Please enter a 2fa code (not from this yubikey)', {mask: true})
  } else {
    throw new Error('add 2fa to your account first')
  }
  yield heroku.request({
    path: `/account/yubikeys`,
    method: 'post',
    body: {otp: otp},
    headers: {
      'Heroku-Two-Factor-Code': secondFactor
    }
  })
  cli.log('Yubikey added.')
}

module.exports = {
  topic: '2fa',
  command: 'yubikeys:add',
  description: 'add a yubikey to this account',
  help: 'You will be prompted to press it.',
  needsAuth: true,
  run: cli.command(co.wrap(run))
}
