'use strict'

let cli = require('heroku-cli-util')
let co = require('co')

function * run (context, heroku) {
  let yubikeys = yield heroku.request({path: '/account/yubikeys'})
  if (yubikeys.length === 0) {
    cli.log('No yubikeys registered.')
  } else {
    cli.styledHeader('Yubikeys')
    for (let yubikey of yubikeys) cli.log(`${yubikey.id} ${yubikey.public_id}`)
  }
}

module.exports = {
  topic: '2fa',
  command: 'yubikeys',
  description: 'list yubikeys for this account',
  needsAuth: true,
  run: cli.command(co.wrap(run))
}
